﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Editors;
using System.ComponentModel;

namespace MultiComboWithSelectedValue
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        MainVM _vm;
        public MainWindow()
        {
            InitializeComponent();

            _vm = new MainVM();
            DataContext = _vm;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            _vm.SelectedID = 5;
        }
    }

    public class XamComboEditorEx : XamComboEditor
    {
        public XamComboEditorEx()
        {
            DefaultStyleKey = typeof(XamComboEditor);
        }         

        public string SelectedValuePath
        {
            get { return (string)GetValue(SelectedValuePathProperty); }
            set { SetValue(SelectedValuePathProperty, value); }
        }

        public static readonly DependencyProperty SelectedValuePathProperty =
            DependencyProperty.Register(
                "SelectedValuePath", 
                typeof(string), 
                typeof(XamComboEditorEx), 
                new PropertyMetadata(null));



        public object SelectedValue
        {
            get { return (object)GetValue(SelectedValueProperty); }
            set { SetValue(SelectedValueProperty, value); }
        }

        public static readonly DependencyProperty SelectedValueProperty =
            DependencyProperty.Register(
                "SelectedValue",
                typeof(object),
                typeof(XamComboEditorEx),
                new PropertyMetadata(null,
                    (ss, ee) =>
                    {
                        XamComboEditorEx combo = ss as XamComboEditorEx;
                        if (ee.NewValue != null)
                        {
                            if (combo.ItemsSource != null)
                            {
                                foreach (var item in combo.ItemsSource)
                                {
                                    var itemValue = item.GetType().GetProperty(combo.SelectedValuePath).GetValue(item, null);
                                    if (itemValue != null && ee.NewValue.Equals(itemValue))
                                    {
                                        combo.SelectedItem = item;
                                        break;
                                    }
                                }
                            }
                        }
                        else
                        {
                            combo.SelectedItem = null;
                        } 
                    }));


        protected override void OnSelectionChanged()
        {
            base.OnSelectionChanged();

            if (SelectedItem != null)
                SelectedValue = SelectedItem.GetType().GetProperty(SelectedValuePath).GetValue(SelectedItem, null);
            else
                SelectedValue = null;
        }
    }

    public class MainVM : INotifyPropertyChanged
    {
        public List<Data> Data { get; set; }

        public MainVM()
        {
            Data = new List<Data>();
            for (int i = 0; i < 10; i++)
            {
                Data.Add(new Data
                {
                    ID = i,
                    Name = "Item " + i,
                });
            }

            SelectedID = 2;
        }

        private int selected;

        public int SelectedID
        {
            get { return selected; }
            set
            {
                selected = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("SelectedID"));
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
    }
}
